// vim: set filetype=pp2html:
=Introduction

* \B<PerlPoint> is a presentation creation framework written in Perl.

* It was originally designed by Tom Christiansen.

=Sectioning

* Separate different sections with "=[SECTION NAME]".

* == is a sub-section. === is a sub-sub-section, etc.

=Points

* Designate points with asterisks (*) if they are bulleted, and pound signs
if they are numeric (#).

# One

# Two

# Three

==Nesting Points

* Nest Points with >'s and demote them with <'s.

>

# This is a nested item.

# And here's another one

=Comments

* Comment start with // and extend to the end of the line

=Texts

A standalone paragraph will be rendered as a paragraph of text.

Like this!

=Blocks

* Blocks are indented from the main text.

    A sample block with \B<bold> and \U<underline> that 
    has several lines of input.

* There are also verbatim blocks that are formated like here documents:

<<EOF
    A here document block with \B<bold> and \U<underline>
EOF

=Styles

* \\B<Text> makes the text bold: \B<Text>

* \\I<Text> makes the text italic: \I<Text>

* \\U<Text> makes the text underlined: \U<Text>.

* \\C<Text> denotes a code: \C<Text>

=Images

Here is an image:

\IMAGE{src="gvim_64x64.png" alt="The GVim Editor"}

Its code is 

<<EOF
\IMAGE{src="gvim_64x64.png" alt="The GVim Editor"}
EOF

=Hyperlinks

* The format of a link is \\L{url="target"}<text of hyperlink>:

* Like this : \L{url="http://www.vim.org/"}<The Vim Editor>.

* Warning! This feature is HTML-specific.

=What's More

* Tables (limited support).

* Defining your own macros.

* Invocation from Perl

* Customization of Header and Footer

* Other stuff I forgot.

=The End

Bye! And may your code be brief but effective.




